Index: /trunk/prototype/modules/mail/templates/new_message.ejs
===================================================================
--- /trunk/prototype/modules/mail/templates/new_message.ejs	(revision 6930)
+++ /trunk/prototype/modules/mail/templates/new_message.ejs	(revision 7113)
@@ -63,5 +63,5 @@
 				<td class="value" style="width: 100%;">
 					<div class="email-area ui-corner-all">
-						<input class="new-message-input to email-text" name="input_aux_to" type="text" value="" autocomplete="off"/>	
+						<textarea class="new-message-input to email-text" name="input_aux_to" type="text" value="" autocomplete="off"></textarea>	
 					</div>
 					<textarea class="new-message-input to" name="input_to" style="width:99%; resize: none;display : none;"></textarea>
@@ -76,5 +76,5 @@
 				<td class="value">
 					<div class="email-area ui-corner-all">
-						<input class="new-message-input cc email-text" name="input_aux_cc" type="text" value="" autocomplete="off"/>	
+						<textarea class="new-message-input cc email-text" name="input_aux_cc" type="text" value="" autocomplete="off"></textarea>	
 					</div>
 					<textarea class="new-message-input cc" name="input_cc" style="width:99%; resize: none;display : none;"></textarea>
@@ -89,5 +89,5 @@
 				<td class="value">
 					<div class="email-area ui-corner-all">
-						<input class="new-message-input cco email-text" name="input_aux_cco" type="text" value="" autocomplete="off"/>	
+						<textarea class="new-message-input cco email-text" name="input_aux_cco" type="text" value="" autocomplete="off"></textarea>	
 					</div>
 					<textarea class="new-message-input cco" name="input_cco" style="width:99%; resize: none;display : none;"></textarea>
@@ -100,5 +100,5 @@
                 <td class="value" style="width: 100%;">
                     <div class="email-area ui-corner-all">
-                        <input class="new-message-input reply-to email-text" name="input_aux_reply_to" type="text" value="" autocomplete="off"/>    
+                        <textarea class="new-message-input reply-to email-text" name="input_aux_reply_to" type="text" value="" autocomplete="off"></textarea>	
                     </div>
                     <textarea class="new-message-input reply-to" name="input_reply_to" style="width:99%; resize: none;display : none;"></textarea>
Index: /trunk/expressoMail1_2/templates/default/main.css
===================================================================
--- /trunk/expressoMail1_2/templates/default/main.css	(revision 6996)
+++ /trunk/expressoMail1_2/templates/default/main.css	(revision 7113)
@@ -1573,2 +1573,9 @@
 .div-addtask  #calendar_addtask_details8 .parent .child-top .afterValue { width: 150px; float: left; background: #E8F4FD; height: 20px; font-weight: bold; color: #2E6E9E;  text-align: center;}
 .div-addtask  #calendar_addtask_details8 .parent .child-top .afterValue span{display: block; padding: 6px; }
+
+.new-message-input.email-text{
+	resize: none;
+	height: 16px;
+	overflow: hidden;
+	vertical-align: middle;
+}
Index: /trunk/expressoMail1_2/js/main.js
===================================================================
--- /trunk/expressoMail1_2/js/main.js	(revision 7103)
+++ /trunk/expressoMail1_2/js/main.js	(revision 7113)
@@ -926,18 +926,22 @@
 		else
 			mail_msg = Element("tbody_box");
-		
+
+		if ( preferences.use_shortcuts == '1') {
+				//Last msg is selected
+				if (mail_msg && exist_className(mail_msg.childNodes[mail_msg.childNodes.length-1], 'selected_shortcut_msg') ) {
+					select_msg('null', 'up', true);
+				}
+				else {
+					if (!select_msg('null', 'down', true)) {
+						select_msg('null', 'up', true);
+					}
+				}
+			}
+
 		if(data.status == false){
 			write_msg(get_lang("You don't have permission for this operation in this shared folder!"));
 			return false;
 		}
-		if ( preferences.use_shortcuts == '1'){
-			var lastSelected = $("#tbody_box").find("tr input:checked").last().parent().parent();
-			var msgToSelect = lastSelected.next().length > 0 ? lastSelected.next() : lastSelected.prev();	
-			$("#divScrollMain_0").find("#tbody_box").find("tr").each(function(){
-                    $(this).prev().removeClass("current_selected_shortcut_msg");
-                    $(this).removeClass("selected_shortcut_msg");
-			});		
-			select_msg(msgToSelect.attr("id"));
-		}
+
 		if (show_success_msg){
 			if (data.msgs_number.length == 1)
@@ -982,7 +986,7 @@
 				if (msg_to_delete){
 						removeAll(msg_to_delete.id);
-						 delete selectedPagingMsgs[data.msgs_number[i]];
-				} 
-		totalFolderMsgs = totalFolderMsgs - data.msgs_number.length;
+						 delete selectedPagingMsgs[data.msgs_number[i]]; 
+				}
+				 totalFolderMsgs = totalFolderMsgs - data.msgs_number.length; 
 		}
 		Element('tot_m').innerHTML = parseInt(Element('tot_m').innerHTML) - data.msgs_number.length;
@@ -1185,9 +1189,6 @@
 				return false;
 			}else{
-				write_msg(get_lang('Error moving message.')+" "+get_lang('Permission denied to folder "%1".', new_folder_name));
-				/*Verifica se a pasta destino é a "Trash" e se a pasta origem e destino são do mesma estrutura compartilhada*/
-				if(new_folder_name == "Trash" && folder.split("/")[1] == new_folder.split("/")[1]){
-					alert(get_lang("You can not remove the message with the preference 'Send to Trash' enabled. There is no permission to move messages to the trash folder."));
-				}
+				data = data.split("/").reverse(); //Recupera o nome da pasta do array
+				write_msg(get_lang('Error moving message.')+" "+get_lang('Permission denied to folder "%1".', data[0]));
 				return false;
 			}
@@ -2225,5 +2226,5 @@
 	array = break_comma(value);
 	$.each(array, function(index, value){
-		draw_email_box(value, context.find("."+field).filter("input"));
+		draw_email_box(value, context.find("."+field).filter("textarea:first"));
 	});
 }
Index: /trunk/expressoMail1_2/js/draw_api.js
===================================================================
--- /trunk/expressoMail1_2/js/draw_api.js	(revision 7111)
+++ /trunk/expressoMail1_2/js/draw_api.js	(revision 7113)
@@ -3963,5 +3963,5 @@
 					}
 					else{
-						tamanho += 7.1;
+						tamanho += 7.2;
 					}
 				}
@@ -3973,5 +3973,5 @@
 			}
 			input.parent().scrollTo(":last");	
-		}, 100);
+		}, 10);
 	})
 	//AO SAIR DO FOCO MONTAGEM DA CAIXA DE EMAIL
@@ -4004,17 +4004,26 @@
 		var pthis = $(this);
 		setTimeout(function() {
-			if(pthis.val().split('"') > 1)
+			if(pthis.val().split('"').length > 1)
 				var str = pthis.val().replace(/[,;\t]/gi, ",");	
 			else
-				var str = pthis.val().replace(/[,;\t\n\s]/gi, ",");
+				var str = pthis.val().replace(/[,;\t\n]/gi, ",");
 			str = str.split(",");
-			$.each(str, function(index, value){
-				draw_email_box(value, pthis);
-			});
-			pthis.val("");
+
+			if(str.length != 1){
+				$.each(str, function(index, value){
+					draw_email_box(value, pthis);
+				});
+			}else if(str[0].split(" ").length == 1){
+				draw_email_box(str[0], pthis);
+			}else{
+				$(pthis).val(str[0]);				
+				return false;
+			}
+			$(pthis).val("");
 		}, 50);
 	});
 	//SE FOR EDIÇÃO DE EMAILS RECALCULA O INPUT E SETA O FOCO
 	if(input.hasClass("box-input")){
+		input.css("max-width",parseInt(input.parents(".email-area:first").css("width"))-15);
 		input.trigger("keydown");
 		input.focus();
@@ -4208,5 +4217,5 @@
 	div.click(function(e){
 		if(e.target == $(this)[0]){
-			$(this).find("input:last").focus();
+			$(this).find("textarea:last").focus();
 			$(this).find("div").removeClass("box-selected");
 		}
@@ -4241,5 +4250,5 @@
 	
 	//MAKE KEYDOWN
-	input_keydowns(div.find("input"), ID);
+	input_keydowns(div.find("textarea"), ID);
 	
 	
@@ -4280,5 +4289,5 @@
 		});
 		//INSERÇÃO DO AUTO COMPLETE AO INPUT
-		div.find("input").catcomplete({
+		div.find("textarea").catcomplete({
 			minLength: 1,			
 			source: function(request, response){
@@ -4383,5 +4392,5 @@
 		canMakeBox = false;
 		if(!$(":focus").hasClass("new-message-input"))
-			emQuickSearch(($(this).parents("tr:first").find("input").val() ? $(this).parents("tr:first").find("input").val() : input_search), "."+$(this).parents("tr:first").attr('class').split("-")[0], ID, undefined, true);
+			emQuickSearch(($(this).parents("tr:first").find("textarea").val() ? $(this).parents("tr:first").find("textarea").val() : input_search), "."+$(this).parents("tr:first").attr('class').split("-")[0], ID, undefined, true);
 	});
 }
@@ -4441,10 +4450,10 @@
 		field.find(".email-area div").remove();
 		if(!field.find("textarea").hasClass("track")){
-			field.find("textarea").css({"max-height" : "115px", "overflow-y" : "auto"}).addClass("track");	
+			field.find("textarea").css({"max-height" : "115px", "overflow-y" : "hidden", "max-width" : parseInt(content.find(".email-area").css("width"))-28}).addClass("track").focus();	
 			input_binds(field.find(".email-area"), ID);
 		}
 	} 
 	
-	input_binds(content.find('[name="input_aux_to"]').css("max-width" , parseInt(content.find(".email-area").css("width"))-5).focus().parent().css({"max-height" : "115px", "overflow-y" : "auto"}), ID);	
+	input_binds(content.find('[name="input_aux_to"]').css("max-width" , parseInt(content.find(".email-area").css("width"))-28).focus().parent().css({"max-height" : "115px", "overflow-y" : "auto"}), ID);	
 	
 	//Botão TextoRico/TextoSimples
Index: /trunk/expressoMail1_2/js/QuickCatalogSearch.js
===================================================================
--- /trunk/expressoMail1_2/js/QuickCatalogSearch.js	(revision 6910)
+++ /trunk/expressoMail1_2/js/QuickCatalogSearch.js	(revision 7113)
@@ -719,13 +719,13 @@
 				draw_email_box(
 					(data_[index][ldap_id.toLowerCase()] ? data_[index][ldap_id.toLowerCase()][0] : final_contact)
-					, content.find(field_).filter("input")
+					, content.find(field_).filter("textarea:first")
 				);
 			}else{
-				draw_email_box(final_contact, content.find(field_).filter("input"));
+				draw_email_box(final_contact, content.find(field_).filter("textarea:first"));
 			}
 		}else{
-			draw_email_box((data_[index].id_contact ? data_[index].id_contact : data_[index].id), content.find(field_).filter("input"), (data_[index].id_contact ? true : "G"));
+			draw_email_box((data_[index].id_contact ? data_[index].id_contact : data_[index].id), content.find(field_).filter("textarea:first"), (data_[index].id_contact ? true : "G"));
 		}
-		content.find(field_).filter("input").val("");
+		content.find(field_).filter("textarea:first").val("");
 		button.onclick = function(){
 			remove_contact_field(document.getElementById(divs).innerHTML, button, divs);