Index: /branches/2.4/prototype/modules/mail/templates/new_message.ejs
===================================================================
--- /branches/2.4/prototype/modules/mail/templates/new_message.ejs	(revision 6754)
+++ /branches/2.4/prototype/modules/mail/templates/new_message.ejs	(revision 7122)
@@ -62,5 +62,5 @@
 				<td class="value" style="width: 100%;">
 					<div class="email-area ui-corner-all">
-						<input class="new-message-input to email-text" name="input_aux_to" type="text" value="" autocomplete="off"/>	
+						<textarea class="new-message-input to email-text" name="input_aux_to" type="text" value="" autocomplete="off"></textarea>	
 					</div>
 					<textarea class="new-message-input to" name="input_to" style="width:99%; resize: none;display : none;"></textarea>
@@ -75,5 +75,5 @@
 				<td class="value">
 					<div class="email-area ui-corner-all">
-						<input class="new-message-input cc email-text" name="input_aux_cc" type="text" value="" autocomplete="off"/>	
+						<textarea class="new-message-input cc email-text" name="input_aux_cc" type="text" value="" autocomplete="off"></textarea>	
 					</div>
 					<textarea class="new-message-input cc" name="input_cc" style="width:99%; resize: none;display : none;"></textarea>
@@ -88,5 +88,5 @@
 				<td class="value">
 					<div class="email-area ui-corner-all">
-						<input class="new-message-input cco email-text" name="input_aux_cco" type="text" value="" autocomplete="off"/>	
+						<textarea class="new-message-input cco email-text" name="input_aux_cco" type="text" value="" autocomplete="off"></textarea>	
 					</div>
 					<textarea class="new-message-input cco" name="input_cco" style="width:99%; resize: none;display : none;"></textarea>
Index: /branches/2.4/expressoMail1_2/templates/default/main.css
===================================================================
--- /branches/2.4/expressoMail1_2/templates/default/main.css	(revision 6938)
+++ /branches/2.4/expressoMail1_2/templates/default/main.css	(revision 7122)
@@ -1400,2 +1400,9 @@
         background-color : #BBBBBB; 
 } 
+
+.new-message-input.email-text{ 
+        resize: none; 
+        height: 16px; 
+        overflow: hidden; 
+        vertical-align: middle; 
+}
Index: /branches/2.4/expressoMail1_2/js/main.js
===================================================================
--- /branches/2.4/expressoMail1_2/js/main.js	(revision 7112)
+++ /branches/2.4/expressoMail1_2/js/main.js	(revision 7122)
@@ -883,4 +883,5 @@
 						removeAll(msg_to_delete.id);
 				}
+				totalFolderMsgs = totalFolderMsgs - data.msgs_number.length;
 		}
 		Element('tot_m').innerHTML = parseInt(Element('tot_m').innerHTML) - data.msgs_number.length;
@@ -1083,9 +1084,6 @@
 				return false;
 			}else{
-				write_msg(get_lang('Error moving message.')+" "+get_lang('Permission denied to folder "%1".', new_folder_name)); 
-                /*Verifica se a pasta destino é a "Trash" e se a pasta origem e destino são do mesma estrutura compartilhada*/ 
-                if(new_folder_name == "Trash" && folder.split("/")[1] == new_folder.split("/")[1]){ 
-                        alert(get_lang("You can not remove the message with the preference 'Send to Trash' enabled. There is no permission to move messages to the trash folder.")); 
-                } 
+				data = data.split("/").reverse(); //Recupera o nome da pasta do array 
+                write_msg(get_lang('Error moving message.')+" "+get_lang('Permission denied to folder "%1".', data[0])); 
 				return false;
 			}
@@ -2108,5 +2106,5 @@
 	array = value.split(",");
 	$.each(array, function(index, value){
-		draw_email_box(value, context.find("."+field).filter("input"));
+		draw_email_box(value, context.find("."+field).filter("textarea:first"));
 	});
 }
Index: /branches/2.4/expressoMail1_2/js/draw_api.js
===================================================================
--- /branches/2.4/expressoMail1_2/js/draw_api.js	(revision 7099)
+++ /branches/2.4/expressoMail1_2/js/draw_api.js	(revision 7122)
@@ -3809,5 +3809,5 @@
 					}
 					else{
-						tamanho += 7.1;
+						tamanho += 7.2;
 					}
 				}
@@ -3819,5 +3819,5 @@
 			}
 			input.parent().scrollTo(":last");	
-		}, 100);
+		}, 10);
 	})
 	//AO SAIR DO FOCO MONTAGEM DA CAIXA DE EMAIL
@@ -3850,20 +3850,27 @@
 		var pthis = $(this);
 		setTimeout(function() {
-			if(pthis.val().split('"') > 1) 
+			if(pthis.val().split('"').length > 1)
 	                var str = pthis.val().replace(/[,;\t]/gi, ",");  
 	        else 
-	                var str = pthis.val().replace(/[,;\t\n\s]/gi, ","); 
+	                var str = pthis.val().replace(/[,;\t\n]/gi, ",");
 			str = str.split(",");
-			$.each(str, function(index, value){
-				draw_email_box(value, pthis);
-			});
-			pthis.val("");
+			if(str.length != 1){ 
+                    $.each(str, function(index, value){ 
+                            draw_email_box(value, pthis); 
+                    }); 
+            }else if(str[0].split(" ").length == 1){ 
+                    draw_email_box(str[0], pthis); 
+            }else{ 
+                    $(pthis).val(str[0]);                            
+                    return false; 
+            } 
+            $(pthis).val(""); 
 		}, 50);
 	});
 	//SE FOR EDIÇÃO DE EMAILS RECALCULA O INPUT E SETA O FOCO
-	if(input.hasClass("box-input")){
+	input.css("max-width",parseInt(input.parents(".email-area:first").css("width"))-15);
 		input.trigger("keydown");
 		input.focus();
-	}
+	
 }
 var input_search = "";
@@ -4053,5 +4060,5 @@
 	div.click(function(e){
 		if(e.target == $(this)[0]){
-			$(this).find("input:last").focus();
+			$(this).find("textarea:last").focus(); 
 			$(this).find("div").removeClass("box-selected");
 		}
@@ -4086,5 +4093,5 @@
 	
 	//MAKE KEYDOWN
-	input_keydowns(div.find("input"), ID);
+    input_keydowns(div.find("textarea"), ID); 
 	
 	
@@ -4125,5 +4132,5 @@
 		});
 		//INSERÇÃO DO AUTO COMPLETE AO INPUT
-		div.find("input").catcomplete({
+		div.find("textarea").catcomplete({
 			minLength: 1,			
 			source: function(request, response){
@@ -4228,5 +4235,5 @@
 		canMakeBox = false; 
 		if(!$(":focus").hasClass("new-message-input"))
-			emQuickSearch(($(this).parents("tr:first").find("input").val() ? $(this).parents("tr:first").find("input").val() : input_search), "."+$(this).parents("tr:first").attr('class').split("-")[0], ID, undefined, true);
+			emQuickSearch(($(this).parents("tr:first").find("textarea").val() ? $(this).parents("tr:first").find("textarea").val() : input_search), "."+$(this).parents("tr:first").attr('class').split("-")[0], ID, undefined, true); 
 	});
 }
@@ -4286,10 +4293,10 @@
 		field.find(".email-area div").remove();
 		if(!field.find("textarea").hasClass("track")){
-			field.find("textarea").css({"max-height" : "115px", "overflow-y" : "auto"}).addClass("track");	
+			field.find("textarea").css({"max-height" : "115px", "overflow-y" : "hidden", "max-width" : parseInt(content.find(".email-area").css("width"))-28}).addClass("track").focus();	
 			input_binds(field.find(".email-area"), ID);
 		}
 	} 
 	
-	input_binds(content.find('[name="input_aux_to"]').css("max-width" , parseInt(content.find(".email-area").css("width"))-5).focus().parent().css({"max-height" : "115px", "overflow-y" : "auto"}), ID);	
+	input_binds(content.find('[name="input_aux_to"]').css("max-width" , parseInt(content.find(".email-area").css("width"))-28).focus().parent().css({"max-height" : "115px", "overflow-y" : "auto"}), ID);	
 	
 	//Botão TextoRico/TextoSimples
Index: /branches/2.4/expressoMail1_2/js/QuickCatalogSearch.js
===================================================================
--- /branches/2.4/expressoMail1_2/js/QuickCatalogSearch.js	(revision 6931)
+++ /branches/2.4/expressoMail1_2/js/QuickCatalogSearch.js	(revision 7122)
@@ -719,13 +719,13 @@
 				draw_email_box(
 					(data_[index][ldap_id.toLowerCase()] ? data_[index][ldap_id.toLowerCase()][0] : final_contact)
-					, content.find(field_).filter("input")
+					, content.find(field_).filter("textarea:first") 
 				);
 			}else{
-				draw_email_box(final_contact, content.find(field_).filter("input"));
+				draw_email_box(final_contact, content.find(field_).filter("textarea:first"))
 			}
 		}else{
-			draw_email_box((data_[index].id_contact ? data_[index].id_contact : data_[index].id), content.find(field_).filter("input"), (data_[index].id_contact ? true : "G"));
+			draw_email_box((data_[index].id_contact ? data_[index].id_contact : data_[index].id), content.find(field_).filter("textarea:first"), (data_[index].id_contact ? true : "G")); 
 		}
-		content.find(field_).filter("input").val("");
+		content.find(field_).filter("textarea:first").val(""); 
 		button.onclick = function(){
 			remove_contact_field(document.getElementById(divs).innerHTML, button, divs);