Index: trunk/prototype/plugins/datejs/sugarpak-debug.js
===================================================================
--- trunk/prototype/plugins/datejs/sugarpak-debug.js	(revision 5341)
+++ trunk/prototype/plugins/datejs/sugarpak-debug.js	(revision 7143)
@@ -1,8 +1,9 @@
 /**
- * Version: 1.0 Alpha-1 
- * Build Date: 12-Nov-2007
- * Copyright (c) 2006-2007, Coolite Inc. (http://www.coolite.com/). All rights reserved.
- * License: Licensed under The MIT License. See license.txt and http://www.datejs.com/license/. 
- * Website: http://www.datejs.com/ or http://www.coolite.com/datejs/
+ * @version: 1.0 Alpha-1
+ * @author: Coolite Inc. http://www.coolite.com/
+ * @date: 2008-04-13
+ * @copyright: Copyright (c) 2006-2008, Coolite Inc. (http://www.coolite.com/). All rights reserved.
+ * @license: Licensed under The MIT License. See license.txt and http://www.datejs.com/license/. 
+ * @website: http://www.datejs.com/
  */
 
@@ -13,134 +14,297 @@
  */
  
-/**
- * Gets a date that is set to the current date and time. 
- * @return {Date}    The current date and time.
- */
-Date.now = function () {
-    return new Date();
-};
-
-/** 
- * Gets a date that is set to the current date. The time is set to the start of the day (00:00 or 12:00 AM).
- * @return {Date}    The current date.
- */
-Date.today = function () {
-    return Date.now().clearTime();
-};
-
-// private
-Date.prototype._orient = +1;
-
-/** 
- * Moves the date to the next instance of a date as specified by a trailing date element function (eg. .day(), .month()), month name function (eg. .january(), .jan()) or day name function (eg. .friday(), fri()).
- * Example
-<pre><code>
-Date.today().next().friday();
-Date.today().next().fri();
-Date.today().next().march();
-Date.today().next().mar();
-Date.today().next().week();
-</code></pre>
- * 
- * @return {Date}    this
- */
-Date.prototype.next = function () {
-    this._orient = +1;
-    return this;
-};
-
-/** 
- * Moves the date to the previous instance of a date as specified by a trailing date element function (eg. .day(), .month()), month name function (eg. .january(), .jan()) or day name function (eg. .friday(), fri()).
- * Example
-<pre><code>
-Date.today().last().friday();
-Date.today().last().fri();
-Date.today().last().march();
-Date.today().last().mar();
-Date.today().last().week();
-</code></pre>
- *  
- * @return {Date}    this
- */
-Date.prototype.last = Date.prototype.prev = Date.prototype.previous = function () {
-    this._orient = -1;
-    return this;
-};
-
-// private
-Date.prototype._is = false;
-    
-/** 
- * Performs a equality check when followed by either a month name or day name function.
- * Example
-<pre><code>
-Date.today().is().friday(); // true|false
-Date.today().is().fri();
-Date.today().is().march();
-Date.today().is().mar();
-</code></pre>
- *  
- * @return {bool}    true|false
- */
-Date.prototype.is = function () { 
-    this._is = true; 
-    return this; 
-}; 
-
-// private
-Number.prototype._dateElement = "day";
-
-/** 
- * Creates a new Date (Date.now()) and adds this (Number) to the date based on the preceding date element function (eg. second|minute|hour|day|month|year).
- * Example
-<pre><code>
-// Undeclared Numbers must be wrapped with parentheses. Requirment of JavaScript.
-(3).days().fromNow();
-(6).months().fromNow();
-
-// Declared Number variables do not require parentheses. 
-var n = 6;
-n.months().fromNow();
-</code></pre>
- *  
- * @return {Date}    A new Date instance
- */
-Number.prototype.fromNow = function () {
-    var c = {};
-    c[this._dateElement] = this;
-    return Date.now().add(c);
-};
-
-/** 
- * Creates a new Date (Date.now()) and subtract this (Number) from the date based on the preceding date element function (eg. second|minute|hour|day|month|year).
- * Example
-<pre><code>
-// Undeclared Numbers must be wrapped with parentheses. Requirment of JavaScript.
-(3).days().ago();
-(6).months().ago();
-
-// Declared Number variables do not require parentheses. 
-var n = 6;
-n.months().ago();
-</code></pre>
- *  
- * @return {Date}    A new Date instance
- */
-Number.prototype.ago = function () {
-    var c = {};
-    c[this._dateElement] = this * -1;
-    return Date.now().add(c);
-};
-
-// Build dynamic date element, month name and day name functions.
 (function () {
-    var $D = Date.prototype, $N = Number.prototype;
-
-    /* Do NOT modify the following string tokens. These tokens are used to build dynamic functions. */
+    var $D = Date, $P = $D.prototype, $C = $D.CultureInfo, $N = Number.prototype;
+
+    // private
+    $P._orient = +1;
+
+    // private
+    $P._nth = null;
+
+    // private
+    $P._is = false;
+
+    // private
+    $P._same = false;
+    
+    // private
+    $P._isSecond = false;
+
+    // private
+    $N._dateElement = "day";
+
+    /** 
+     * Moves the date to the next instance of a date as specified by the subsequent date element function (eg. .day(), .month()), month name function (eg. .january(), .jan()) or day name function (eg. .friday(), fri()).
+     * Example
+    <pre><code>
+    Date.today().next().friday();
+    Date.today().next().fri();
+    Date.today().next().march();
+    Date.today().next().mar();
+    Date.today().next().week();
+    </code></pre>
+     * 
+     * @return {Date}    date
+     */
+    $P.next = function () {
+        this._orient = +1;
+        return this;
+    };
+
+    /** 
+     * Creates a new Date (Date.today()) and moves the date to the next instance of the date as specified by the subsequent date element function (eg. .day(), .month()), month name function (eg. .january(), .jan()) or day name function (eg. .friday(), fri()).
+     * Example
+    <pre><code>
+    Date.next().friday();
+    Date.next().fri();
+    Date.next().march();
+    Date.next().mar();
+    Date.next().week();
+    </code></pre>
+     * 
+     * @return {Date}    date
+     */    
+    $D.next = function () {
+        return $D.today().next();
+    };
+
+    /** 
+     * Moves the date to the previous instance of a date as specified by the subsequent date element function (eg. .day(), .month()), month name function (eg. .january(), .jan()) or day name function (eg. .friday(), fri()).
+     * Example
+    <pre><code>
+    Date.today().last().friday();
+    Date.today().last().fri();
+    Date.today().last().march();
+    Date.today().last().mar();
+    Date.today().last().week();
+    </code></pre>
+     *  
+     * @return {Date}    date
+     */
+    $P.last = $P.prev = $P.previous = function () {
+        this._orient = -1;
+        return this;
+    };
+
+    /** 
+     * Creates a new Date (Date.today()) and moves the date to the previous instance of the date as specified by the subsequent date element function (eg. .day(), .month()), month name function (eg. .january(), .jan()) or day name function (eg. .friday(), fri()).
+     * Example
+    <pre><code>
+    Date.last().friday();
+    Date.last().fri();
+    Date.previous().march();
+    Date.prev().mar();
+    Date.last().week();
+    </code></pre>
+     *  
+     * @return {Date}    date
+     */
+    $D.last = $D.prev = $D.previous = function () {
+        return $D.today().last();
+    };    
+
+    /** 
+     * Performs a equality check when followed by either a month name, day name or .weekday() function.
+     * Example
+    <pre><code>
+    Date.today().is().friday(); // true|false
+    Date.today().is().fri();
+    Date.today().is().march();
+    Date.today().is().mar();
+    </code></pre>
+     *  
+     * @return {Boolean}    true|false
+     */
+    $P.is = function () { 
+        this._is = true; 
+        return this; 
+    };
+
+    /** 
+     * Determines if two date objects occur on/in exactly the same instance of the subsequent date part function.
+     * The function .same() must be followed by a date part function (example: .day(), .month(), .year(), etc).
+     *
+     * An optional Date can be passed in the date part function. If now date is passed as a parameter, 'Now' is used. 
+     *
+     * The following example demonstrates how to determine if two dates fall on the exact same day.
+     *
+     * Example
+    <pre><code>
+    var d1 = Date.today(); // today at 00:00
+    var d2 = new Date();   // exactly now.
+
+    // Do they occur on the same day?
+    d1.same().day(d2); // true
+    
+     // Do they occur on the same hour?
+    d1.same().hour(d2); // false, unless d2 hour is '00' (midnight).
+    
+    // What if it's the same day, but one year apart?
+    var nextYear = Date.today().add(1).year();
+
+    d1.same().day(nextYear); // false, because the dates must occur on the exact same day. 
+    </code></pre>
+     *
+     * Scenario: Determine if a given date occurs during some week period 2 months from now. 
+     *
+     * Example
+    <pre><code>
+    var future = Date.today().add(2).months();
+    return someDate.same().week(future); // true|false;
+    </code></pre>
+     *  
+     * @return {Boolean}    true|false
+     */    
+    $P.same = function () { 
+        this._same = true;
+        this._isSecond = false;
+        return this; 
+    };
+
+    /** 
+     * Determines if the current date/time occurs during Today. Must be preceded by the .is() function.
+     * Example
+    <pre><code>
+    someDate.is().today();    // true|false
+    new Date().is().today();  // true
+    Date.today().is().today();// true
+    Date.today().add(-1).day().is().today(); // false
+    </code></pre>
+     *  
+     * @return {Boolean}    true|false
+     */    
+    $P.today = function () {
+        return this.same().day();
+    };
+
+    /** 
+     * Determines if the current date is a weekday. This function must be preceded by the .is() function.
+     * Example
+    <pre><code>
+    Date.today().is().weekday(); // true|false
+    </code></pre>
+     *  
+     * @return {Boolean}    true|false
+     */
+    $P.weekday = function () {
+        if (this._is) { 
+            this._is = false;
+            return (!this.is().sat() && !this.is().sun());
+        }
+        return false;
+    };
+
+    /** 
+     * Sets the Time of the current Date instance. A string "6:15 pm" or config object {hour:18, minute:15} are accepted.
+     * Example
+    <pre><code>
+    // Set time to 6:15pm with a String
+    Date.today().at("6:15pm");
+
+    // Set time to 6:15pm with a config object
+    Date.today().at({hour:18, minute:15});
+    </code></pre>
+     *  
+     * @return {Date}    date
+     */
+    $P.at = function (time) {
+        return (typeof time === "string") ? $D.parse(this.toString("d") + " " + time) : this.set(time);
+    }; 
+        
+    /** 
+     * Creates a new Date() and adds this (Number) to the date based on the preceding date element function (eg. second|minute|hour|day|month|year).
+     * Example
+    <pre><code>
+    // Undeclared Numbers must be wrapped with parentheses. Requirment of JavaScript.
+    (3).days().fromNow();
+    (6).months().fromNow();
+
+    // Declared Number variables do not require parentheses. 
+    var n = 6;
+    n.months().fromNow();
+    </code></pre>
+     *  
+     * @return {Date}    A new Date instance
+     */
+    $N.fromNow = $N.after = function (date) {
+        var c = {};
+        c[this._dateElement] = this;
+        return ((!date) ? new Date() : date.clone()).add(c);
+    };
+
+    /** 
+     * Creates a new Date() and subtract this (Number) from the date based on the preceding date element function (eg. second|minute|hour|day|month|year).
+     * Example
+    <pre><code>
+    // Undeclared Numbers must be wrapped with parentheses. Requirment of JavaScript.
+    (3).days().ago();
+    (6).months().ago();
+
+    // Declared Number variables do not require parentheses. 
+    var n = 6;
+    n.months().ago();
+    </code></pre>
+     *  
+     * @return {Date}    A new Date instance
+     */
+    $N.ago = $N.before = function (date) {
+        var c = {};
+        c[this._dateElement] = this * -1;
+        return ((!date) ? new Date() : date.clone()).add(c);
+    };
+
+    // Do NOT modify the following string tokens. These tokens are used to build dynamic functions.
+    // All culture-specific strings can be found in the CultureInfo files. See /trunk/src/globalization/.
     var dx = ("sunday monday tuesday wednesday thursday friday saturday").split(/\s/),
         mx = ("january february march april may june july august september october november december").split(/\s/),
         px = ("Millisecond Second Minute Hour Day Week Month Year").split(/\s/),
+        pxf = ("Milliseconds Seconds Minutes Hours Date Week Month FullYear").split(/\s/),
+		nth = ("final first second third fourth fifth").split(/\s/),
         de;
-    
+
+   /** 
+     * Returns an object literal of all the date parts.
+     * Example
+    <pre><code>
+	var o = new Date().toObject();
+	
+	// { year: 2008, month: 4, week: 20, day: 13, hour: 18, minute: 9, second: 32, millisecond: 812 }
+	
+	// The object properties can be referenced directly from the object.
+	
+	alert(o.day);  // alerts "13"
+	alert(o.year); // alerts "2008"
+    </code></pre>
+     *  
+     * @return {Date}    An object literal representing the original date object.
+     */
+    $P.toObject = function () {
+        var o = {};
+        for (var i = 0; i < px.length; i++) {
+            o[px[i].toLowerCase()] = this["get" + pxf[i]]();
+        }
+        return o;
+    }; 
+   
+   /** 
+     * Returns a date created from an object literal. Ignores the .week property if set in the config. 
+     * Example
+    <pre><code>
+	var o = new Date().toObject();
+	
+	return Date.fromObject(o); // will return the same date. 
+
+    var o2 = {month: 1, day: 20, hour: 18}; // birthday party!
+    Date.fromObject(o2);
+    </code></pre>
+     *  
+     * @return {Date}    An object literal representing the original date object.
+     */    
+    $D.fromObject = function(config) {
+        config.week = null;
+        return Date.today().set(config);
+    };
+        
     // Create day name functions and abbreviated day name functions (eg. monday(), friday(), fri()).
     var df = function (n) {
@@ -150,10 +314,55 @@
                 return this.getDay() == n; 
             }
+            if (this._nth !== null) {
+                // If the .second() function was called earlier, remove the _orient 
+                // from the date, and then continue.
+                // This is required because 'second' can be used in two different context.
+                // 
+                // Example
+                //
+                //   Date.today().add(1).second();
+                //   Date.march().second().monday();
+                // 
+                // Things get crazy with the following...
+                //   Date.march().add(1).second().second().monday(); // but it works!!
+                //  
+                if (this._isSecond) {
+                    this.addSeconds(this._orient * -1);
+                }
+                // make sure we reset _isSecond
+                this._isSecond = false;
+
+                var ntemp = this._nth;
+                this._nth = null;
+                var temp = this.clone().moveToLastDayOfMonth();
+                this.moveToNthOccurrence(n, ntemp);
+                if (this > temp) {
+                    throw new RangeError($D.getDayName(n) + " does not occur " + ntemp + " times in the month of " + $D.getMonthName(temp.getMonth()) + " " + temp.getFullYear() + ".");
+                }
+                return this;
+            }			
             return this.moveToDayOfWeek(n, this._orient);
         };
     };
     
-    for (var i = 0 ; i < dx.length ; i++) { 
-        $D[dx[i]] = $D[dx[i].substring(0, 3)] = df(i);
+    var sdf = function (n) {
+        return function () {
+            var t = $D.today(), shift = n - t.getDay();
+            if (n === 0 && $C.firstDayOfWeek === 1 && t.getDay() !== 0) {
+                shift = shift + 7;
+            }
+            return t.addDays(shift);
+        };
+    };
+	
+    for (var i = 0; i < dx.length; i++) {
+        // Create constant static Day Name variables. Example: Date.MONDAY or Date.MON
+        $D[dx[i].toUpperCase()] = $D[dx[i].toUpperCase().substring(0, 3)] = i;
+
+        // Create Day Name functions. Example: Date.monday() or Date.mon()
+        $D[dx[i]] = $D[dx[i].substring(0, 3)] = sdf(i);
+
+        // Create Day Name instance functions. Example: Date.today().next().monday()
+        $P[dx[i]] = $P[dx[i].substring(0, 3)] = df(i);
     }
     
@@ -169,19 +378,58 @@
     };
     
-    for (var j = 0 ; j < mx.length ; j++) { 
-        $D[mx[j]] = $D[mx[j].substring(0, 3)] = mf(j);
+    var smf = function (n) {
+        return function () {
+            return $D.today().set({ month: n, day: 1 });
+        };
+    };
+    
+    for (var j = 0; j < mx.length; j++) {
+        // Create constant static Month Name variables. Example: Date.MARCH or Date.MAR
+        $D[mx[j].toUpperCase()] = $D[mx[j].toUpperCase().substring(0, 3)] = j;
+
+        // Create Month Name functions. Example: Date.march() or Date.mar()
+        $D[mx[j]] = $D[mx[j].substring(0, 3)] = smf(j);
+
+        // Create Month Name instance functions. Example: Date.today().next().march()
+        $P[mx[j]] = $P[mx[j].substring(0, 3)] = mf(j);
     }
     
     // Create date element functions and plural date element functions used with Date (eg. day(), days(), months()).
-    var ef = function (j) { 
+    var ef = function (j) {
         return function () {
-            if (j.substring(j.length - 1) != "s") { 
+            // if the .second() function was called earlier, the _orient 
+            // has alread been added. Just return this and reset _isSecond.
+            if (this._isSecond) {
+                this._isSecond = false;
+                return this;
+            }
+
+            if (this._same) {
+                this._same = this._is = false; 
+                var o1 = this.toObject(),
+                    o2 = (arguments[0] || new Date()).toObject(),
+                    v = "",
+                    k = j.toLowerCase();
+                    
+                for (var m = (px.length - 1); m > -1; m--) {
+                    v = px[m].toLowerCase();
+                    if (o1[v] != o2[v]) {
+                        return false;
+                    }
+                    if (k == v) {
+                        break;
+                    }
+                }
+                return true;
+            }
+            
+            if (j.substring(j.length - 1) != "s") {
                 j += "s"; 
             }
-            return this["add" + j](this._orient); 
-        };
-    };
-    
-    // Create date element functions and plural date element functions used with Number (eg. day(), days(), months()).
+            return this["add" + j](this._orient);
+        };
+    };
+    
+    
     var nf = function (n) {
         return function () {
@@ -190,70 +438,38 @@
         };
     };
-    
-    for (var k = 0 ; k < px.length ; k++) {
+   
+    for (var k = 0; k < px.length; k++) {
         de = px[k].toLowerCase();
-        $D[de] = $D[de + "s"] = ef(px[k]);
+    
+        // Create date element functions and plural date element functions used with Date (eg. day(), days(), months()).
+        $P[de] = $P[de + "s"] = ef(px[k]);
+        
+        // Create date element functions and plural date element functions used with Number (eg. day(), days(), months()).
         $N[de] = $N[de + "s"] = nf(de);
     }
+    
+    $P._ss = ef("Second");
+	
+    var nthfn = function (n) {
+        return function (dayOfWeek) {
+            if (this._same) {
+                return this._ss(arguments[0]);
+            }
+            if (dayOfWeek || dayOfWeek === 0) {
+                return this.moveToNthOccurrence(dayOfWeek, n);
+            }
+            this._nth = n;
+
+            // if the operator is 'second' add the _orient, then deal with it later...
+            if (n === 2 && (dayOfWeek === undefined || dayOfWeek === null)) {
+                this._isSecond = true;
+                return this.addSeconds(this._orient);
+            }
+            return this;
+        };
+    };
+
+    for (var l = 0; l < nth.length; l++) {
+        $P[nth[l]] = (l === 0) ? nthfn(-1) : nthfn(l);
+    }
 }());
-
-/**
- * Converts the current date instance into a JSON string value.
- * @return {String}  JSON string of date
- */
-Date.prototype.toJSONString = function () {
-    return this.toString("yyyy-MM-ddThh:mm:ssZ");
-};
-
-/**
- * Converts the current date instance to a string using the culture specific shortDatePattern.
- * @return {String}  A string formatted as per the culture specific shortDatePattern
- */
-Date.prototype.toShortDateString = function () {
-    return this.toString(Date.CultureInfo.formatPatterns.shortDatePattern);
-};
-
-/**
- * Converts the current date instance to a string using the culture specific longDatePattern.
- * @return {String}  A string formatted as per the culture specific longDatePattern
- */
-Date.prototype.toLongDateString = function () {
-    return this.toString(Date.CultureInfo.formatPatterns.longDatePattern);
-};
-
-/**
- * Converts the current date instance to a string using the culture specific shortTimePattern.
- * @return {String}  A string formatted as per the culture specific shortTimePattern
- */
-Date.prototype.toShortTimeString = function () {
-    return this.toString(Date.CultureInfo.formatPatterns.shortTimePattern);
-};
-
-/**
- * Converts the current date instance to a string using the culture specific longTimePattern.
- * @return {String}  A string formatted as per the culture specific longTimePattern
- */
-Date.prototype.toLongTimeString = function () {
-    return this.toString(Date.CultureInfo.formatPatterns.longTimePattern);
-};
-
-/**
- * Get the ordinal suffix of the current day.
- * @return {String}  "st, "nd", "rd" or "th"
- */
-Date.prototype.getOrdinal = function () {
-    switch (this.getDate()) {
-    case 1: 
-    case 21: 
-    case 31: 
-        return "st";
-    case 2: 
-    case 22: 
-        return "nd";
-    case 3: 
-    case 23: 
-        return "rd";
-    default: 
-        return "th";
-    }
-};