Index: sandbox/2.5.0-expresso1/expressoMail1_2/js/mail_archiver.js
===================================================================
--- sandbox/2.5.0-expresso1/expressoMail1_2/js/mail_archiver.js	(revision 7157)
+++ sandbox/2.5.0-expresso1/expressoMail1_2/js/mail_archiver.js	(revision 7172)
@@ -1391,5 +1391,9 @@
     var folder_num_msgs = expresso_mail_archive.folder.nummessages;
     //window.alert('num = ' + folder_num_msgs);
-    alternate_border(0);
+
+    //Marcosw início - Inserido comentário no código pois fazia com que se removesse a aba de listagem de emails
+    //alternate_border(0);
+    //Marcosw fim
+    
     Element("border_id_0").innerHTML = "&nbsp;" + lang_folder(fcaption) + '&nbsp;<font face="Verdana" size="1" color="#505050">[<span id="new_m">&nbsp;</span> / <span id="tot_m"></span>]</font>';
     draw_box(data_to_draw, 'local_' + expresso_mail_archive.currentfolder, true);
Index: sandbox/2.5.0-expresso1/expressoMail1_2/js/main.js
===================================================================
--- sandbox/2.5.0-expresso1/expressoMail1_2/js/main.js	(revision 7166)
+++ sandbox/2.5.0-expresso1/expressoMail1_2/js/main.js	(revision 7172)
@@ -1361,6 +1361,10 @@
 	} catch (e) {} 
 
+    //Marcosw inicio - Inserida validação para recuperar o id caso não seja aba de listagem
 	if(currentTab == 0)
 		msgs_number = get_selected_messages();
+	else
+		msgs_number = currentTab.substr(0,currentTab.indexOf('_r'));
+    //Marcosw fim
 
 	if(openTab.type[currentTab] == 1){
@@ -4837,5 +4841,4 @@
 //MAILARCHIVER-04
 function services_retry(){
-	console.log("services_retry");
     try{
         connector.purgeCache(); 
Index: sandbox/2.5.0-expresso1/expressoMail1_2/js/messages_controller.js
===================================================================
--- sandbox/2.5.0-expresso1/expressoMail1_2/js/messages_controller.js	(revision 7157)
+++ sandbox/2.5.0-expresso1/expressoMail1_2/js/messages_controller.js	(revision 7172)
@@ -159,7 +159,12 @@
 		if (folder == 'null')
 			folder = get_current_folder();
-		if (msgs_number == 'selected')
-			msgs_number = get_selected_messages();
-		
+
+        //Marcosw inicio - Inserida validação para recuperar o id caso não seja aba de listagem
+		if (msgs_number == 'selected' && currentTab != 0) //Recupera apenas o id da mensagem aberta
+			msgs_number = currentTab.substr(0,currentTab.indexOf('_r'));
+        else
+            msgs_number = get_selected_messages();
+        //Marcos fim
+
 		if(currentTab != 0 && currentTab.indexOf("search_")  >= 0){
 			var content_search = document.getElementById('content_id_'+currentTab);
@@ -187,4 +192,7 @@
                                     expresso_mail_archive.folder_destination = 'trash';
                                     expresso_mail_archive.moveMessages(expresso_mail_archive.folder_destination, msgs_number);
+                                    //Marcos Início - É preciso remover a aba da mensagem para que a próxima seja exibida
+                                    delete_border(currentTab,'false'); 
+                                    //Marcos fim
                                     expresso_mail_archive.getMessage(previous_msg);
                                 }
@@ -192,4 +200,7 @@
                                 else{
                                     expresso_mail_archive.deleteMessages(msgs_number);
+                                    //Marcos Início - É preciso remover a aba da mensagem para que a próxima seja exibida
+                                    delete_border(currentTab,'false'); 
+                                    //Marcos fim
                                     expresso_mail_archive.getMessage(previous_msg)
                                 }                                                                                
@@ -202,4 +213,7 @@
                                     expresso_mail_archive.folder_destination = 'trash';
                                     expresso_mail_archive.moveMessages(expresso_mail_archive.folder_destination, msgs_number);
+                                    //Marcos Início - É preciso remover a aba da mensagem para que a próxima seja exibida
+                                    delete_border(currentTab,'false');
+                                    //Marcos Fim
                                     expresso_mail_archive.getMessage(previous_msg);
                                 }
@@ -207,4 +221,7 @@
                                 else{
                                     expresso_mail_archive.deleteMessages(msgs_number);
+                                    //Marcos Início - É preciso remover a aba da mensagem para que a próxima seja exibida
+                                    delete_border(currentTab,'false'); 
+                                    //Marcos Fim
                                     expresso_mail_archive.getMessage(previous_msg)
                                 }                                          
@@ -481,7 +498,10 @@
             }                    
 
-            if(msgs_number=='selected'){
+            //Marcosw inicio - Inserida validação para recuperar o id caso não seja aba de listagem
+            if (msgs_number == 'selected' && currentTab != 0) //Recupera apenas o id da mensagem aberta
+                msgs_number = currentTab.substr(0,currentTab.indexOf('_r'));
+            else
                 msgs_number = get_selected_messages();
-            }
+            //Marcosw fim
 
             if (new_folder == 'local_root'){
@@ -493,4 +513,7 @@
                     //esta tirando de um folder local para outro folder local
                     expresso_mail_archive.moveMessages(new_folder.substr(6), msgs_number);
+                    //Marcos Início - É preciso remover a aba da mensagem copiada
+                    delete_border(currentTab,'false'); 
+                    //Marcos fim
                 }
                 else{